clang-tools 6.0.0

Public Member Functions | List of all members
clang::tidy::cppcoreguidelines::NoMallocCheck Class Reference

This checker is concerned with C-style memory management and suggest modern alternatives to it. More...

`#include <NoMallocCheck.h>`

Inheritance diagram for clang::tidy::cppcoreguidelines::NoMallocCheck:
[legend]
Collaboration diagram for clang::tidy::cppcoreguidelines::NoMallocCheck:
[legend]

## Public Member Functions
| NoMallocCheck (StringRef Name, ClangTidyContext *Context)
| Construct Checker and read in configuration for function names. More...
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Make configuration of checker discoverable. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Registering for malloc, calloc, realloc and free calls. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| Checks matched function calls and gives suggestion to modernize the code. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

This checker is concerned with C-style memory management and suggest modern alternatives to it.

The check is only enabled in C++. For analyzing malloc calls see Clang Static Analyzer - unix.Malloc.

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/cppcoreguidelines-no-malloc.html

Definition at line 28 of file NoMallocCheck.h.

## Constructor & Destructor Documentation

## ◆ NoMallocCheck()

clang::tidy::cppcoreguidelines::NoMallocCheck::NoMallocCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |
| inline

Construct Checker and read in configuration for function names.

Definition at line 31 of file NoMallocCheck.h.

References registerMatchers(), and storeOptions().

## Member Function Documentation

## ◆ check()

void clang::tidy::cppcoreguidelines::NoMallocCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

Checks matched function calls and gives suggestion to modernize the code.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 63 of file NoMallocCheck.cpp.

## ◆ registerMatchers()

void clang::tidy::cppcoreguidelines::NoMallocCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Registering for malloc, calloc, realloc and free calls.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 40 of file NoMallocCheck.cpp.

Referenced by NoMallocCheck().

## ◆ storeOptions()

void clang::tidy::cppcoreguidelines::NoMallocCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Opts | ) |
| override virtual

Make configuration of checker discoverable.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 34 of file NoMallocCheck.cpp.

Referenced by NoMallocCheck().

The documentation for this class was generated from the following files:

- NoMallocCheck.h
- NoMallocCheck.cpp